//-----------------------------------------------------------------------------
//
//			->	 11 -   OnPaint, LButtonDbl      MFC
//			->	http://www.firststeps.ru
//	  07.08.2002
//  :      ->    evgeniu@atnet.ru
//-----------------------------------------------------------------------------
#include "afxwin.h"						// MFC    

#define APPNAME "http://www.firststeps.ru    11 -   OnPaint, LButtonDbl      MFC"
#include <d3d8.h>

#pragma comment (lib, "d3d8.lib")

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };};
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };};

class CMainWnd : public CFrameWnd
{
private:
	LPDIRECT3D8             p_d3d;				//    
	LPDIRECT3DDEVICE8		p_d3d_Device;		//   d3d8
	D3DDISPLAYMODE			d3ddm;
	DECLARE_MESSAGE_MAP()
public: 
	int color;
	CMainWnd();							//   
	~CMainWnd(void);					//   
	afx_msg void OnPaint();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
};

BEGIN_MESSAGE_MAP(CMainWnd, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

CMainWnd::~CMainWnd(void)
{
	_RELEASE_	(p_d3d_Device);
	_DELETE_	(p_d3d_Device);
	_RELEASE_	(p_d3d);
	_DELETE_	(p_d3d);
}

CMainWnd::CMainWnd()
{ 

	Create(NULL, APPNAME,				//   
		WS_POPUP,
		rectDefault, NULL,NULL);

	p_d3d = Direct3DCreate8 (D3D_SDK_VERSION);
	
	p_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm);

	D3DPRESENT_PARAMETERS d3dpp; 
	ZeroMemory (&d3dpp, sizeof(d3dpp));
	d3dpp.BackBufferWidth = 1024;
	d3dpp.BackBufferHeight = 768;
	d3dpp.BackBufferCount = 3;
	d3dpp.FullScreen_RefreshRateInHz = d3ddm.RefreshRate;
	d3dpp.Windowed = false;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = d3ddm.Format;

	p_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, m_hWnd, 
		D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &p_d3d_Device);
}

void CMainWnd::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	DestroyWindow();					//   
}

void CMainWnd::OnPaint()
{
    SetCursor(NULL);

	p_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET,
		D3DCOLOR_XRGB (color++, 0, 0), 0.0f, 0);

    p_d3d_Device->BeginScene ();
    p_d3d_Device->EndScene ();

    p_d3d_Device->Present (NULL, NULL, NULL, NULL);
}

class CMyApp : public CWinApp
{
public: 
	CMyApp();							//    
	virtual BOOL InitInstance();		//  
};

CMyApp::CMyApp()						//    
{

}

BOOL CMyApp::InitInstance()				//  
{ 
	m_pMainWnd=new CMainWnd();			//    
	ASSERT(m_pMainWnd);					//    
	m_pMainWnd->ShowWindow(SW_SHOW);	//   
	m_pMainWnd->UpdateWindow();			//   
	
	return TRUE;						//    
};

//   
CMyApp theApp;							//  